﻿Imports System.Drawing
Imports Microsoft.Office.Core

<Runtime.InteropServices.ComVisible(True)>
Public Class TmRibbon
    Implements Office.IRibbonExtensibility

    Private ribbon As Office.IRibbonUI

    Public Sub New()
    End Sub

    Public Function GetCustomUI(ByVal ribbonID As String) As String Implements Office.IRibbonExtensibility.GetCustomUI
        Return GetResourceText("Tickmarks.TmRibbon.xml")
    End Function

#Region "Ribbon Callbacks"
    Public Sub Ribbon_Load(ByVal ribbonUI As Office.IRibbonUI)
        Me.ribbon = ribbonUI
    End Sub

    Public Sub OnActionTickMark(control As IRibbonControl)
        If control.Id = "btnTickMarkDel" Then
            Globals.Tickmarks.DeleteAllTickmarks()
            Exit Sub
        End If
        Globals.Tickmarks.DoIt(My.Resources.ResourceManager.GetObject(Replace(control.Tag, "r_", "t_")))
    End Sub

    Public Function GetImage(ByVal control As IRibbonControl) As Bitmap
        Dim pic As Bitmap
        pic = My.Resources.ResourceManager.GetObject(control.Tag)
        Return New Bitmap(pic)
    End Function

#End Region

#Region "Helpers"

    Private Shared Function GetResourceText(ByVal resourceName As String) As String
        Dim asm As Reflection.Assembly = Reflection.Assembly.GetExecutingAssembly()
        Dim resourceNames() As String = asm.GetManifestResourceNames()
        For i As Integer = 0 To resourceNames.Length - 1
            If String.Compare(resourceName, resourceNames(i), StringComparison.OrdinalIgnoreCase) = 0 Then
                Using resourceReader As IO.StreamReader = New IO.StreamReader(asm.GetManifestResourceStream(resourceNames(i)))
                    If resourceReader IsNot Nothing Then
                        Return resourceReader.ReadToEnd()
                    End If
                End Using
            End If
        Next
        Return Nothing
    End Function

#End Region

End Class
